package lib;

class Rect {

	private final tr:Pos;
	private final bl:Pos;

	public function new(p1: Pos,p2:Pos) {
		this.tr = {
			x: MathI.max(p1.x,p2.x),
			y: MathI.max(p1.y,p2.y)
		};

		this.bl = {
			x: MathI.min(p1.x,p2.x),
			y: MathI.min(p1.y,p2.y)
		};
	}

	public function getSize(): Int {
		return (tr.x - bl.x) * (tr.y - bl.y);
	}

	public function isInside(p: Pos): Bool {
		return (p.x >= bl.x && p.x <= tr.x) && (p.y >= bl.y && p.y <= tr.y);
	}

	public function isOutside(p: Pos): Bool {
		return !this.isInside(p);
	}

	public function getHight(): Int {
		return tr.y - bl.y;
	}

	public function getWidth(): Int {
		return tr.x - bl.x;
	}
}
